package eu.mhsl.minenet.minigames.instance.game.minigame.types.bedwars;

import eu.mhsl.minenet.minigames.instance.game.minigame.Minigame;
import eu.mhsl.minenet.minigames.instance.game.minigame.config.ConfigManager;
import eu.mhsl.minenet.minigames.instance.game.minigame.config.GameFactory;
import eu.mhsl.minenet.minigames.instance.game.minigame.config.Option;
import eu.mhsl.minenet.minigames.instance.game.minigame.config.restriction.RestrictionHandler;
import eu.mhsl.minenet.minigames.instance.game.minigame.config.restriction.common.MinimalPlayeramountGameRestriction;
import eu.mhsl.minenet.minigames.message.component.TranslatedComponent;
import net.minestom.server.item.Material;

import java.util.Map;

public class BedwarsFactory implements GameFactory {
    @Override
    public TranslatedComponent name() {
        return TranslatedComponent.byId("game_Bedwars#name");
    }

    @Override
    public ConfigManager configuration() {
        return null;
    }

    @Override
    public RestrictionHandler globalRestrictions() {
        return new RestrictionHandler()
                .addRestriction(new MinimalPlayeramountGameRestriction(2));
    }

    @Override
    public Material symbol() {
        return Material.RED_BED;
    }

    @Override
    public TranslatedComponent description() {
        return TranslatedComponent.byId("game_Bedwars#description");
    }

    @Override
    public Minigame manufacture(Map<String, Option<?>> configuration) {
        return new Bedwars();
    }
}
